#if !defined(_FONTDA_H_)
#define _FONTDA_H_

enum useful_fontda_constants
{
  DRVR_MIN = 12,
  DRVR_MAX = 31,
  FONT_MIN = 0,
  FONT_MAX = 32767,
  NFNT_MIN = 0,
  NFNT_MAX = 32767,
  FOND_MIN = 0,
  FOND_MAX = 32767
};

#define CHARS_NEEDED(n) ((((long) n)+31)/32*4)

typedef unsigned char uchar;

typedef short boolean_t;

typedef struct
{
  ResType type;
  long max;
  long free;
  uchar bitmap[CHARS_NEEDED(DRVR_MAX)];
} drvr_map_t;

typedef struct
{
  ResType type;
  long max;
  long free;
  uchar bitmap[CHARS_NEEDED(FONT_MAX)];
} font_map_t;

typedef struct
{
  ResType type;
  long max;
  long free;
  uchar bitmap[CHARS_NEEDED(NFNT_MAX)];
} nfnt_map_t;

typedef struct
{
  ResType type;
  long max;
  long free;
  uchar bitmap[CHARS_NEEDED(FOND_MAX)];
} fond_map_t;

enum constant_to_allow_compilation
{
  SHIM_FOR_GENERIC_MAP_TO_COMPILE = 4
};

typedef struct
{
  ResType type;
  long max;
  long free;
  uchar bitmap[SHIM_FOR_GENERIC_MAP_TO_COMPILE];
} generic_map_t;

typedef struct
{
  drvr_map_t drvr_map;
  font_map_t font_map;
  nfnt_map_t nfnt_map;
  fond_map_t fond_map;
  ResType sentinel;
} in_use_t, *in_use_ptr, **in_use_hand;

typedef struct mapping_link_str
{
  short old_id;
  short new_id;
  struct mapping_link_str *next;
} mapping_link_t;

typedef struct
{
  ResType type;
  mapping_link_t *head;
} mapping_list_t;

typedef struct
{
  mapping_list_t list[4];
} mapping_t;

typedef struct
{
  short size;
  short style;
  short id;
} font_assoc_t;

typedef struct link_str
{
  struct link_str *next;
  Handle resource;
} link_t;

OSErr AddToMasterFile (short from_file_rn, short master_file_rn);

#endif