#include "windlist.h"
#include "go.h"

typedef struct browser_link_str
{
  WindowPtr wp;
  struct browser_link_str *next;
} browser_link_t;

static browser_link_t *head;

void
add_browser_window (WindowPtr wp)
{
  browser_link_t *newp;
  
  newp = (browser_link_t *) NewPtr (sizeof (*newp));
  newp->next = head;
  newp->wp = wp;
  head = newp;
}

static browser_link_t **
findpp (WindowPtr wp)
{
  browser_link_t **retval;
  
  for (retval = &head; *retval && (*retval)->wp != wp; retval = &(*retval)->next)
    ;
  return retval;
}

void
remove_browser_window (WindowPtr wp)
{
  browser_link_t **pp;
  
  pp = findpp (wp);
  if (*pp)
    {
      browser_link_t *p;
      
      p = *pp;
      *pp = p->next;
      DisposePtr ((Ptr) p);
    }
}


boolean_t
browser_window_p (WindowPtr wp)
{
  return *(findpp (wp)) ? TRUE : FALSE;
}

boolean_t
browser_or_hotband_window_p (WindowPtr wp)
{
  return wp == g_hotband || browser_window_p (wp);
}